#pragma once
#include <vector>
#include <algorithm>
using namespace std;

// Structure for the Nelder-Mead settings
struct NMinputs{
	int N;
	double MaxIters; 
	double Tolerance;
};

class CNelderMead {
public:
	CNelderMead(void);
	~CNelderMead(void);

	// Function to calculate the mean value of
	// a set of n vectors each of dimension n
	// namely a (n x n) matrix
	vector<double> CNelderMead::VMean(vector<vector<double> > X, int n);

	// Function to add two vectors together
	vector<double> CNelderMead::VAdd(vector<double> x, vector<double> y);

	// Function to subtract two vectors
	vector<double> CNelderMead::VSub(vector<double> x, vector<double> y);

	// Function to multiply a vector by a constant
	vector<double> CNelderMead::VMult(vector<double> x, double a);

	// Nelder Mead Algorithm
	vector<double> CNelderMead::NelderMeadFunction(double (*f)(vector<double>), NMinputs inputs,vector<vector<double> > StartingValues);
};

